DECLARE EXTERNAL SUB Horner2 ! NewtonSDFig.BAS
OPTION BASE 0
DIM coef(3)            ! Synthetic Division
DEF f(x)=coef(0)*x^3+coef(1)*x^2+coef(2)*x+coef(3)
MAT coef=ZER
let coef(0)=1
let coef(1)=0
let coef(2)=-15
let coef(3)=-4
INPUT x
let i=0
let r=1
SET WINDOW -6,6,-50,50
DRAW GRID
PLOT LINES: x,0;
 DO UNTIL abs(r) < 0.01
     let i=i+1
     call Horner2(3,coef,x,r,s)
     PLOT LINES: x,r;
     LET x=x-r/s
     PLOT LINES: x,0;
     print x;r;"i=";i;r;s
!    print USING "##.###############";fx
  LOOP
  print "Converged";x;r;"N=";i
  PLOT LINES
FOR x=-5 TO 5 STEP 0.1
   PLOT LINES: x,f(x);
NEXT x
END
EXTERNAL SUB Horner2(n,a(),x,r,s)
OPTION BASE 0
LET r=a(0)
LET s=a(0)
FOR i=1 TO n-1     ! i=1             i=2                i=3
   LET r=r*x+a(i)  ! b1=a(0)*x+a(1)  b2=b1*x+a(2)       b3=b2*x+a(3)
   LET s=s*x+r     ! s =a(0)*x+b1    s=(a(0)*x+b1)*x+b2 s=((a(0)*x+b1)*x+b2)*x+b3
NEXT i
LET r=r*x+a(n)
END SUB
