REM   SUBROUTINE jacobi(a,lda,n,v,nrot) \prog\sit\symeig.f
DIM a(15,15),v(15,15)
INPUT PROMPT "n=":n
for i=1 to n
   for j=1 to n
      LET a(i,j)=n-MAX(i,j)+1
   next j
NEXT i
gosub 500
for i=1 to n
   print "eigval=";a(i,i)
next i
STOP
REM  ==============================================
500 LET maxit=n*4
    LET nrot=0
    for j=1 to n
       for i=1 to n
          LET v(i,j)=0.
       next i
       LET v(j,j)=1.
    next j 
    REM  ----------------------------------------------
    for k=1 to maxit
       LET s=0.
       for i=1 to n-1
          for j=i+1 to n
             LET s=s+abs(a(i,j))
          next j
       next i
       print "sum of (off-diag)**2=";2*s;" @ iter=";k
       If s=0 then
          print "Subroutine jacobi converged";k-1
          return
       End if
       LET tresh=0.
       for i=1 to n-1
          for j=i+1 to n
             LET g=abs(a(i,j))
             IF abs(a(i,j)) >tresh THEN
                LET h=a(j,j)-a(i,i)
                If abs(h)+g=abs(h) then
                   LET t=a(i,j)/h
                Else
                   LET phi=0.5*h/a(i,j)
                   LET t=1./(abs(phi)+sqr(1.+phi^2))
                   if phi<0 THEN LET t=-t
                End if
                LET c=1./SQR(1+t*t)
                LET s=t*c
                LET tau=s/(1.+c)
                LET h=t*a(i,j)
                LET a(i,i)=a(i,i)-h
                LET a(j,j)=a(j,j)+h
                LET a(i,j)=0.
                for m=1 to i-1
                   LET g=a(m,i)
                   LET h=a(m,j)
                   LET a(m,i)=g-s*(h+g*tau)
                   LET a(m,j)=h+s*(g-h*tau)
                next m
                for m=i+1 to j-1
                   LET g=a(i,m)
                   LET h=a(m,j)
                   LET a(i,m)=g-s*(h+g*tau)
                   LET a(m,j)=h+s*(g-h*tau)
                next m
                for m=j+1 to n
                   LET g=a(i,m)
                   LET h=a(j,m)
                   LET a(i,m)=g-s*(h+g*tau)
                   LET a(j,m)=h+s*(g-h*tau)
                next m
                for m=1 to n
                   LET g=v(m,i)
                   LET h=v(m,j)
                   LET v(m,i)=g-s*(h+g*tau)
                   LET v(m,j)=h+s*(g-h*tau)
                next m
                LET nrot=nrot+1
             END IF
          next j
       next i
    next k
    REM   ----------------------------------------------
    print "Subroutine jacobi NOT converged";maxit
    return
 END
