!***********************************************************
!*   nmC̓̃X^bN\imodule Łj                 *
!***********************************************************
!------------------------------------------------------------
!OvO錾
!------------------------------------------------------------
DECLARE EXTERNAL SUB hanoi
!------------------------------------------------------------
!vbg̏
!------------------------------------------------------------
INPUT PROMPT "́H":n
CALL hanoi(n, "A", "B", "C", 0)
END
!------------------------------------------------------------
!OvO̖{
!------------------------------------------------------------
EXTERNAL SUB hanoi(n, start$, target$, temp$, m)
DECLARE EXTERNAL SUB Stack.PushStack, Stack.PopStack
CALL PushStack(n, start$, target$, temp$, m)
IF n >= 1 THEN
   CALL hanoi(n-1, start$, temp$, target$, 1)
   PRINT "~";
   PRINT n ;
   PRINT " " & start$ & "  " & target$ & " ֓"
   CALL hanoi(n-1, temp$, target$, start$, 2)
END IF
CALL PopStack
END SUB

MODULE Stack
PUBLIC SUB PushStack
PUBLIC SUB PopStack
SHARE NUMERIC sp,stn(10,2)
SHARE STRING stchr$(10,3)
 
LET sp=0    ! X^bN|C^[
EXTERNAL SUB PushStack(n,start$, target$, temp$, m)
   DECLARE EXTERNAL SUB PlotChr.plotch4
   CLEAR
   FOR k=1 to sp
      CALL plotch4(stn(k,1), stchr$(k,1), stchr$(k,2),stchr$(k,3),stn(k,2),(k-1)*0.1)
   NEXT k
   CALL plotch4(n, start$, target$, temp$, m, sp*0.1)
   LET sp=sp+1
   LET stn(sp,1)=n
   LET stchr$(sp,1)=start$
   LET stchr$(sp,2)=target$
   LET stchr$(sp,3)=temp$
   LET stn(sp,2)=m
   INPUT PROMPT "pushed, press any key to continue":y$
END SUB
 
EXTERNAL SUB PopStack
   DECLARE EXTERNAL SUB PlotChr.plotch4
   CLEAR
   LET sp=sp-1
   FOR k=1 TO sp
      CALL plotch4(stn(k,1), stchr$(k,1), stchr$(k,2),stchr$(k,3),stn(k,2),(k-1)*0.1)
   NEXT k
   INPUT PROMPT "poped, press any key to continue":y$
END SUB
END MODULE

MODULE PlotChr
PUBLIC SUB PlotCh4
SHARE NUMERIC font(13,32)

CALL PlotIni(13,32)

EXTERNAL SUB PlotCh4(n,start$, target$, temp$, m, bias)
   DIM pxy(32)
   LET x=0.2
   LET y=bias
   CALL encoden(n,pxy)
   CALL plotchar(x,y,pxy)
   LET x=x+0.1
   CALL encode(start$,pxy)
   CALL plotchar(x,y,pxy)
   LET x=x+0.1
   CALL encode(target$,pxy)
   CALL plotchar(x,y,pxy)
   LET x=x+0.1
   CALL encode(temp$,pxy)
   CALL plotchar(x,y,pxy)
   LET x=x+0.1
   CALL encoden(m,pxy)
   CALL plotchar(x,y,pxy)
END SUB

EXTERNAL SUB encoden(n,pxy())
!  encode 1 to 9 and 0 to their font line plot coordinate
   LET i=n
   IF n = 0 THEN LET i=10 
   IF n < 0 OR n > 10 THEN
      PRINT "encoden out of range  "; n
   ELSE
      FOR j=1 to 32
         LET pxy(j)=font(i,j)
      NEXT j
   END IF
END SUB
EXTERNAL SUB encode(char$,pxy())
!  encode A,B,C to their font line plot coordinate
   IF ORD(char$) < 65 OR ORD(char$) > 67 THEN
      PRINT "encode out of range  "; char$
   ELSE
      LET code=ORD(char$)-54
      FOR i=1 TO 32
         LET pxy(i)=font(code,i)
      NEXT i
   END IF
END SUB
EXTERNAL SUB plotchar(px,py,xy())
   LET scal=0.01
   FOR i=1 TO 15
      LET x=scal*xy(i*2-1)+px
      LET y=scal*xy(i*2)+py
      LET nx=xy(i*2+1)
      !    print i,x,y;
      IF nx < 0 THEN GOTO 9
      PLOT LINES: x,y;
   NEXT i
   LET x=scal*xy(31)+px
   LET y=scal*xy(32)+py
9    PLOT LINES: x,y
  END SUB

  EXTERNAL SUB PlotIni(m,n)
     DATA  2,5, 3,6, 3,0, 2,0, 4,0,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! 1 
     DATA  0,5, 1,6, 4,6, 5,5, 5,4, 0,1, 0,0, 5,0,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! 2 
     DATA  0,5, 1,6, 4,6, 5,5, 5,4, 4,3, 2,3, 4,3, 5,2, 5,1, 4,0, 1,0, 0,1, 0,0, 0,0, 0,0  ! 3
     DATA  4,0, 4,6, 0,2, 5,2,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! 4 
     DATA  5,6, 0,6, 0,3, 1,4, 4,4, 5,3, 5,1, 4,0, 1,0, 0,1,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! 5 
     DATA  4,6, 1,6, 0,5, 0,1, 1,0, 4,0, 5,1, 5,3, 4,4, 1,4, 0,3,-1,0, 0,0, 0,0, 0,0, 0,0  ! 6 
     DATA  0,6, 5,6, 4,0,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! 7 
     DATA  4,3, 5,4, 5,5, 4,6, 1,6, 0,5, 0,4, 1,3, 4,3, 5,2, 5,1, 4,0, 1,0, 0,1, 0,2, 1,3  ! 8 
     DATA  5,0, 5,5, 4,6, 2,6, 1,5, 1,4, 2,3, 4,3, 5,4,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! 9
     DATA  6,5, 5,6, 1,6, 0,5, 0,1, 1,0, 5,0, 6,1, 6,5,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! O
     DATA  0,0, 3,6, 5,2, 1,2, 5,2, 6,0,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! A 
     DATA  0,0, 0,6, 4,6, 5,5, 5,4, 4,3, 0,3, 4,3, 5,2, 5,1, 4,0, 0,0,-1,0, 0,0, 0,0, 0,0  ! B
     DATA  5,5, 4,6, 1,6, 0,5, 0,1, 1,0, 4,0, 5,1,-1,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0  ! C 
     FOR i=1 TO m
        FOR j=1 TO n
           READ Sa
           LET font(i,j)=Sa
        NEXT j
     NEXT i
  END SUB
END MODULE



